[![Logo](https://raw.githubusercontent.com/scalabli/quo/master/pics/quo.png)](https://github.com/scalabli/quo)

| Version    | [2022.x](https://quo.rtfd.io)
|------------|----------------------------------------------------------------------------
| Web        | [Documentation📃](https://quo.readthedocs.io/)
| Download   | [Downloads](https://pypi.org/project/quo)
| Source     | [Github](https://github.com/scalabli/quo)


`Forever Scalable`

# Quo

**Quo** is a toolkit for writing Command-Line Interface(CLI) app
lications and a TUI (Text User Interface) framework for Python.                                                                 Quo is making headway towards composing speedy and orderly CLI and TUI applications while forestalling any disappointments brought about by the failure to execute a python application.

Simple to code, easy to learn, and does not come with needless baggage. 

Quo requires Python `3.8` or later. 


Features
- [x] Support for ANSI, RGB and Hex color models
- [x] Support for tabular presentation of data
- [x] Intuitive progressbars
- [x] Code completions
- [x] Nesting of commands
- [x] Customizable Text User Interface _(TUI)_ dialogs
- [x] Automatic help page generation
- [x] Syntax highlighting
- [x] Autosuggestions
- [x] Key Binders


Quo is **simple** If you know Python you can  easily use Quo and it can integrate with just about anything.

```{toctree}
:maxdepth: 3
:caption: Tutorials & Explanations
introduction.rst
printing_text.rst

console.rst
prompt.rst
utils.rst
table.rst
commands.rst
apps.rst
args.rst
exceptions.rst
dialogs.rst
widgets.rst
full_screen_apps.rst
kb.rst
progress.rst
filters.rst
styling
help_text.rst
reference.rst
unicode-support.rst
```

```{toctree}
:maxdepth: 1
:caption: Miscellaneous pages
license.rst
changes.rst
appendix.rst
```


## Donate🎁

In order to for us to maintain this project and grow our community of contributors.
[Donate](https://ko-fi.com/scalabli)



## Getting Help

### Community

For discussions about the usage, development, and the future of quo, please join our Google community

* [Community👨‍👩‍👦‍👦](https://groups.google.com/g/scalabli)

## Resources

### Bug tracker

If you have any suggestions, bug reports, or annoyances please report them
to our issue tracker at 
[Bug tracker](https://github.com/scalabli/quo/issues/) or send an email to:

 📥 scalabli@pm.me





